<?php
/*
  Flag die auf true gesetzt wird wenn ein Bot registriert wird
*/

$failmessage = false;

/* 
  Variablen für die Ausgabe
*/
$timeError = false;

/* Minimale Zeit in Sekunden die nach der Auslieferung der Seite
  vergehen muss um nicht im Botfilter zu landen
*/
$minTime = 5;

/* Maximale Zeit in Sekunden die während des ausfüllens des Formulars verstreichen darf
  manche bots befüllen das Formular und senden es zu einem späteren Zeitpunkt ab um diese
  Art der Sicherheitschecks zu umgehen.
*/
$maxTime = 3600;

$honeypot = isset($_POST['subject']) ? $_POST['subject'] : die('Betreff Feld gelöscht');


/*
  Wenn das Honeypot Feld nicht leer ist, gehen wir davon aus das uns ein Bot
  in die Falle gegangen ist.
*/
if(!empty($honeypot)) {
  $failmessage = true;
}

// funktionen einbinden
include_once('functions.php');

$givenTime = isset($_POST['phone']) ? $_POST['phone'] : die('Timestamp Feld gelöscht');

// dekodiere übergebenen Timestamp
$decryptedTime = openssl_decrypt($givenTime, $cipher, $key, 0, $iv);

// überprüfe ob der übergeben wert überprüft werden konnte
if($decryptedTime) {

  // erstelle aktuellen timestamp
  $currentTime = new DateTime();
  $currentTime = $currentTime->getTimestamp();

  /*
    Jetzt berechnen wir die Sekunden die der User für das Ausfüllen des Formulars
    benötigt hat. Sollte der Wert kleiner als unser Threshold sein, blockieren wir
    die Anfrage.
  */
  if( ($currentTime - $decryptedTime) <= $minTime || ($currentTime - $decryptedTime) >= $maxTime ) {
    $failmessage = true;
    $timeError = 'Minimale Zeit für Ausfüllung unterschritten / überschritten';
  }

} else {
  // gelieferter Wert konnte nicht decypted werden -> Eingabefeld wurde bearbeitet
  $failmessage = true;
  $timeError = 'Verschlüsselter Zeit-String wurde bearbeitet';
}


/*
  In dieser Demo werden die POST Variablen nicht gefiltert und validiert!
*/
$name = $_POST['name'];
$email = $_POST['email'];
$message = $_POST['message'];

?>


<html>
  <head></head>
  <body>
    <p>
      <?php if( $failmessage ) {
        echo '<span style="color:red;font-weight:bold;">Bot Aktivität entdeckt</span>';
      } else {
        echo '<span style="color:green;font-weight:bold;">Keine Bot Aktivität entdeckt</span>';
      }
      ?>
    </p>
    <p>
      Ihr Name: <?php echo $_POST['name']; ?><br>
      Ihre E-Mail: <?php echo $_POST['email'];?><br>
      Ihre Nachricht: <?php echo $_POST['message']; ?>
    </p>
    <p>
    Honeypot: 
    <?php 
    if(!empty($honeypot)) {
      echo '<span style="color:red;font-weight:bold;">ausgefüllt</span><br> ';
      echo 'Eingegebener Text: ' . $honeypot;
    } else {
      echo '<span style="color:green;font-weight:bold;">nicht ausgefüllt</span>';
    } ?>
    <p>
    <p>
      Zeitfeld:
      <?php if( !$timeError ) {
        echo '<span style="color:green;font-weight:bold;">Vergange Zeit in Sekunden:' . ($currentTime - $decryptedTime) . '</span>';
      } else {
        echo '<span style="color:red;font-weight:bold;">' . $timeError . '</span>';
      }?>
    </p>
  </body>
</html>
